# -*- coding: utf-8 -*-

"""Tools to run software"""

# ----------------------- Imports --------------------------------
import os
import subprocess
# My modules

#--------------------------Functions------------------------------

# http://pythonwise.blogspot.fr/2010/04/sourcing-shell-script.html
def shell_source(script):
    """Sometime you want to emulate the action of "source" in bash,
    settings some environment variables. Here is a way to do it.
    :return: environment dictionnary
    """
#    import subprocess
#    import os
    pipe = subprocess.Popen(". %s; env" % script, stdout=subprocess.PIPE, shell=True)
    output = pipe.communicate()[0]
    try:            # pour gérer si setup déjà lancé dans le shell => utf-8' codec can't decode byte 0xe9 in position 2365: invalid continuation byte
        env = dict((line.split("=", 1) for line in output.decode('utf-8').splitlines()))
    except UnicodeDecodeError as e:
#        print(e)
        pass
    else:
        os.environ.update(env)
    return env


def setup_bat(bat_script):
    """
    To setup program on Windows with env.bat batch file modifying environment.
    :param bat_script: script.bat with path
    :return: environment dictionnary
    """
    pipe = subprocess.Popen("%s && set" % bat_script, stdout=subprocess.PIPE, shell=True)
    output = pipe.communicate()[0]
#    try:  # pour gérer si setup déjà lancé dans le shell => utf-8' codec can't decode byte 0xe9 in position 2365: invalid continuation byte
    env = dict((line.split("=", 1) for line in output.decode('utf-8').splitlines()))
#    except UnicodeDecodeError as e:
#        print(e)
#        pass
#    else:
#        os.environ.update(env)
    return env

